﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata;

namespace MSAdminUsuarios.Context
{
    public partial class ModelContext : DbContext
    {
        public ModelContext()
        {
        }

        public ModelContext(DbContextOptions<ModelContext> options)
            : base(options)
        {
        }

        public virtual DbSet<MICROSERVICIO> MICROSERVICIOs { get; set; } = null!;
        public virtual DbSet<PERMISO> PERMISOSMs { get; set; } = null!;
        public virtual DbSet<PERFIL> PERFILESMs { get; set; } = null!;
        public virtual DbSet<PERFILPORUSUARIO> PERFILESPORUSUARIOs { get; set; } = null!;
        public virtual DbSet<USUARIO> USUARIOSMs { get; set; } = null!;
        public virtual DbSet<CorreosArea> CORREOSAREAMS { get; set; } = null!;

        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            if (!optionsBuilder.IsConfigured)
            {
            }
        }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            //modelBuilder.HasDefaultSchema("HIMSCAP"); // => AFQ
            modelBuilder.HasDefaultSchema("ADMIN");

            modelBuilder.Entity<MICROSERVICIO>(entity =>
            {
                entity.HasKey(e => e.NU_PK_MS)
                    .HasName("MICROSERVICIOS_PK");

                entity.ToTable("MICROSERVICIOS");

            });

            modelBuilder.Entity<PERMISO>(entity =>
            {
                entity.HasKey(e => e.NU_PK_PMS)
                    .HasName("PERMISOSMS_PK");

                entity.ToTable("PERMISOSMS");
            });

            modelBuilder.Entity<PERFIL>(entity =>
            {
                entity.HasKey(e => e.NU_PK_PFL)
                    .HasName("PERFILESMS_PK");

                entity.ToTable("PERFILESMS");

            });

            modelBuilder.Entity<PERFILPORUSUARIO>(entity =>
            {
                entity.HasKey(e => e.NU_PK_PFLXUSU)
                    .HasName("PERFILESPORUSUARIO_PK");

                entity.ToTable("PERFILESPORUSUARIO");

            });

            modelBuilder.Entity<USUARIO>(entity =>
            {
                entity.HasKey(e => e.NU_PK_USUMS)
                    .HasName("USUARIOSMS_PK");

                entity.ToTable("USUARIOSMS");

                entity.Property(e => e.CL_FIRMA_USUMS).HasColumnType("CLOB");
            });

            modelBuilder.Entity<CorreosArea>(entity =>
            {
                entity.HasKey(e => e.NU_PK_CORA);

                entity.ToTable("CORREOSAREAMS");

            });

            OnModelCreatingPartial(modelBuilder);
        }

        partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
    }
}
